


void setpixel(int x,int y, unsigned int rgb)
{          
   LcdSetWindow(x,y,1,1); LcdDataStart(); LcdData(rgb); LcdDataEnd();
}


int myabs(int a)
{
   if(a<0) a=a*(-1);
   return a;
}

void line(int x1, int y1, int x2, int y2, unsigned int rgb)
{
	int deltax, deltay, x, y, xinc1,xinc2, yinc1, yinc2,den, num, numadd,numpixels,curpixel;
	
	deltax = myabs(x2 - x1); // The difference between the x's
	deltay = myabs(y2 - y1); // The difference between the y's
//	deltax = (x2 - x1); // The difference between the x's
//	deltay = (y2 - y1); // The difference between the y's

 	x = x1; // Start x off at the first pixel
 	y = y1; // Start y off at the first pixel

	if (x2 >= x1){ // The x-values are increasing
 		xinc1 = 1;
 		xinc2 = 1;
 	}
 	else{ // The x-values are decreasing
 		xinc1 = -1;
 		xinc2 = -1;
 	}
 
 	if (y2 >= y1){ // The y-values are increasing
 		yinc1 = 1;
 		yinc2 = 1;
 	}
 	else{ // The y-values are decreasing
 		yinc1 = -1;
 		yinc2 = -1;
 	}

	if (deltax >= deltay){ // There is at least one x-value for every y-value
 		xinc1 = 0; // Don't change the x when numerator >= denominator
 		yinc2 = 0; // Don't change the y for every iteration
 		den = deltax;
 		num = deltax / 2;
 		numadd = deltay;
 		numpixels = deltax; // There are more x-values than y-values
 	}
	else{ // There is at least one y-value for every x-value
 		xinc2 = 0; // Don't change the x for every iteration
 		yinc1 = 0; // Don't change the y when numerator >= denominator
 		den = deltay;
 		num = deltay / 2;
 		numadd = deltax;
 		numpixels = deltay; // There are more y-values than x-values
 	}
 
 	for (curpixel = 0; curpixel <= numpixels; curpixel++){
                setpixel(x,y,rgb);  // Draw the current pixel
 		num += numadd; // Increase the numerator by the top of the fraction
 		if (num >= den){ // Check if numerator >= denominator
 			num -= den; // Calculate the new numerator value
 			x += xinc1; // Change the x as appropriate
 			y += yinc1; // Change the y as appropriate
 		}
 	x += xinc2; // Change the x as appropriate
 	y += yinc2; // Change the y as appropriate
 	}
}

void rectangle(int x, int y, int xwidth, int ywidth, unsigned int rgb)
{
   line(x,y,x+xwidth,y,rgb);
   line(x+xwidth,y,x+xwidth,y+ywidth,rgb);
   line(x,y,x,y+ywidth,rgb);
   line(x,y+ywidth,x+xwidth,y+ywidth,rgb);
}


void circle( int x1,int y1, int radius,unsigned int rgb)
{  
    int x, y, thres;

    if( radius == 0 ) { setpixel(x,y,rgb); return; }

    y = radius;
    thres = 3 - (radius + radius);

    for( x = 0; x < y; x ++ )
    {
        if( thres < 0 ) {  thres += 6 + (x << 2); }
        else {  thres += 10 + ((x - y) << 2);  y --; }
        setpixel(x1+x,y1+y,rgb);
        setpixel(x1+y,y1+x,rgb);
        setpixel(x1-x,y1+y,rgb);
        setpixel(x1-y,y1+x,rgb);
        setpixel(x1+x,y1-y,rgb);
        setpixel(x1+y,y1-x,rgb);
        setpixel(x1-x,y1-y,rgb);
        setpixel(x1-y,y1-x,rgb);
    }
}
