// I1813 ILLUMINANT LCD(ILI9163B) Library. by NKJ 2010.02.16.

#define RGB(r,g,b)   ( ((r<<8)&0xf800)| ((g<<3)&0x07e0) | (b>>3) )


void LcdWrCmd(unsigned char cmd)   // Write Command
{            
  LcdCs(1);

  LcdRs(0);   //command
  LcdDataH(0x00);
  LcdDataL(cmd);
  LcdWr(1);
  LcdWr(0); 
  
  LcdCs(0);
}

void LcdWrPar(unsigned char par)  // Write Parameter
{ 
  LcdCs(1);

  LcdRs(1);   //parameter
  LcdDataH(0x00);
  LcdDataL(par);
  LcdWr(1);
  LcdWr(0); 
  
  LcdCs(0);
}

void LcdInit(void)
{                   
  LcdCs(0); LcdWr(0); LcdRd(0);  
  
  DDRB=0xff;  // low byte
  DDRC=0xff;  // high byte  
  
  LcdReset(1);
  mdelay(10);
  LcdReset(0);
  mdelay(150);



  LcdWrCmd(0x11);  //Exit Sleep
  mdelay(20);
  LcdWrCmd(0x26);  //Set Default Gamma
  LcdWrPar(0x04);

  LcdWrCmd(0xB1);
  LcdWrPar(0x10);//08
  LcdWrPar(0x04);//10

  LcdWrCmd(0xC0);  //Set VRH1[4:0] & VC[2:0] for VCI1 & GVDD
  LcdWrPar(0x0C);//0x01
  LcdWrPar(0x05);

  LcdWrCmd(0xC1);  //Set BT[2:0] for AVDD & VCL & VGH & VGL
  LcdWrPar(0x02);

  LcdWrCmd(0xC5);  //Set VMH[6:0] & VML[6:0] for VOMH & VCOML
  LcdWrPar(0x29);  //0x36      
  LcdWrPar(0x50);  //0x4B     

  LcdWrCmd(0xC7);
  LcdWrPar(0xBD);//BD

  LcdWrCmd(0x3a);  //Set Color Format
  LcdWrPar(0x05);

  LcdWrCmd(0x2A);  //Set Column Address
  LcdWrPar(0x00);
  LcdWrPar(0x00);
  LcdWrPar(0x00);
  LcdWrPar(0x7F);

  LcdWrCmd(0x2B);  //Set Page Address
  LcdWrPar(0x00);
  LcdWrPar(0x00);
  LcdWrPar(0x00);
  LcdWrPar(0x9F);

 LcdWrCmd(0xB4);
 LcdWrPar(0x07);

  LcdWrCmd(0x36);  //Set Scanning Direction
  LcdWrPar(0xC8);

  LcdWrCmd(0xBF);  //Set Source Output Direction
  LcdWrPar(0x00);
  LcdWrCmd(0xf2);  //Enable Gamma bit
  LcdWrPar(0x01);

  LcdWrCmd(0xE0);
  LcdWrPar(0x18);//p1
  LcdWrPar(0x05);//p2
  LcdWrPar(0x12);//p3
  LcdWrPar(0x1d);//p4
  LcdWrPar(0x28);//p5
  LcdWrPar(0x15);//p6
  LcdWrPar(0x42);//p7
  LcdWrPar(0xB2);//p8
  LcdWrPar(0x2F);//p9
  LcdWrPar(0x13);//p10
  LcdWrPar(0x12);//p11
  LcdWrPar(0x0A);//p12
  LcdWrPar(0x11);//p13
  LcdWrPar(0x0B);//p14
  LcdWrPar(0x06);//p15

  LcdWrCmd(0xE1);
  LcdWrPar(0x09);//p1
  LcdWrPar(0x1c);//p2
  LcdWrPar(0x2d);//p3
  LcdWrPar(0x09);//p4
  LcdWrPar(0x1c);//p5
  LcdWrPar(0x1a);//p6
  LcdWrPar(0x42);//p7
  LcdWrPar(0x44);//p8
  LcdWrPar(0x54);//p9
  LcdWrPar(0x0d);//p10
  LcdWrPar(0x3D);//p11
  LcdWrPar(0x30);//p12
  LcdWrPar(0x38);//p13
  LcdWrPar(0x38);//p14
  LcdWrPar(0x38);//p15


  LcdWrCmd(0x29); // Display On

}


void LcdSetWindow(unsigned char x, unsigned char y, unsigned char width, unsigned char height)
{          
  LcdWrCmd(0x2A);  //Set Column Address
  LcdWrPar(0x00);
  LcdWrPar(x);
  LcdWrPar(0x00);
  LcdWrPar(x+width-1);

  LcdWrCmd(0x2B);  //Set Page Address
  LcdWrPar(0x00);
  LcdWrPar(y);
  LcdWrPar(0x00);
  LcdWrPar(y+height-1);
}

/*
void LcdDataStart(void)
{
  LcdCs(1);

  LcdRs(0);   //register
  LcdDataH(0x00);
  LcdDataL(0x2c); // SRAM Write Control
  LcdWr(1);
  LcdWr(0); 
  LcdRs(1);   //data
}
 
void LcdData(unsigned short rgb)  // format : (rrrrrggg gggbbbbb)bin
{
  LcdDataH(rgb>>8);
  LcdDataL(rgb);
  LcdWr(1);
  LcdWr(0);
} 
              

void LcdDataEnd(void)
{ 
  LcdCs(0);
}
*/
#define LcdDataStart()  {  LcdCs(1);  LcdRs(0);   LcdDataH(0x00);  LcdDataL(0x2c);   LcdWr(1);  LcdWr(0);   LcdRs(1);  }
#define LcdData(rgb)  { LcdDataH(rgb>>8);  LcdDataL(rgb);  LcdWr(1);  LcdWr(0); }      // format : (rrrrrggg gggbbbbb)bin
#define LcdDataEnd()  LcdCs(0)

void LcdSetDirection(unsigned short angle) // 0,90,180,270
{  
   switch(angle)
    {
      case 0:
      LcdWrCmd(0x36); 
      LcdWrPar(0xC8);
      break;
      
      case 90:
      LcdWrCmd(0x36); 
      LcdWrPar(0xa8);
      break;
      
      case 180:
      LcdWrCmd(0x36);
      LcdWrPar(0x08);
      break;
      
      case 270:
      LcdWrCmd(0x36);
      LcdWrPar(0x68);
      break;
      
      default:
      LcdWrCmd(0x36);
      LcdWrPar(0xC8);
      break;
    }
}