void io_init(void)
{
  PORTA=0xD0;
  DDRA=0xFF;

  PORTB=0x00;
  DDRB=0x00;

  PORTC=0x00;
  DDRC=0x00;

  PORTD=0x00;
  DDRD=0x00;

  PORTE=0x4C;
  DDRE=0x94;

  PORTF=0x00;
  DDRF=0x00;

  PORTG=0x04;
  DDRG=0x1C;

  ACSR=0x80;
}


#define CmEndCapture() PINE.6
#define CmReset(X)    PORTE.7=X   

#define CmAddrClock(X) PORTA.3=X
#define CmAddr1(X)     PORTA.2=X
#define CmAddr0(X)     PORTA.1=X
#define CmRdData(X)   PORTA.0=X
#define CmData()      PINF

void CmReadyCapture(unsigned char a)
{
   if(a) PORTG=PORTG|0x08;
   else PORTG=PORTG&0xf7;
}

void CmStartCapture(unsigned char a)
{
   if(a) PORTG=PORTG|0x10;
   else PORTG=PORTG&0xef;
}

void CmSetAddress(unsigned long addr)
{  
   DDRF=0xff;
   
   CmAddr1(0); CmAddr0(1);
   PORTF=addr&0xff;
   CmAddrClock(1); 
   CmAddrClock(0);
                         
   CmAddr1(1); CmAddr0(0);        
   PORTF=(addr>>8)&0xff;        
   CmAddrClock(1); 
   CmAddrClock(0);

   CmAddr1(1); CmAddr0(1);        
   PORTF=(addr>>16)&0xff;
   CmAddrClock(1); 
   CmAddrClock(0);               

   CmAddr1(0); CmAddr0(0);           

   DDRF=0x00;
   PORTF=0x00;
}


void LcdReset(unsigned char a)
{
   if(a) PORTG=PORTG&0xfb;
   else PORTG=PORTG|0x04;
}

#define LcdBl(X)      PORTE.4=X   

#define LcdRd(X)      PORTA.7=(!X)
#define LcdWr(X)      PORTA.6=(!X)
#define LcdRs(X)      PORTA.5=X
#define LcdCs(X)      PORTA.4=(!X)

#define LcdDataH(X)   PORTC=X
#define LcdDataL(X)   PORTB=X



             

